# Copyright (C) 2006-2011 Oracle. All rights reserved.
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation, version 2.  This program is distributed in the hope that it will
# be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
# Public License for more details.  You should have received a copy of the GNU
# General Public License along with this program; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 021110-1307, USA.

import OVSDiscoverExtension
from OVSDiscoverCommon import format_extn_response

# GLG - there isn't currently any plan to use this..should probably be removed
def status(args):
    """
    Obtain status information from an OVM Server.

    This invokes legacy C code from the VI agent.  It returns a subset of
    the data that was available from the VI agent "Status" command.

    @param args string specifying the status to be returned
                Legal values are of the form "Option: name [Option: name ...]"
                Where name is one of:
                All, CPU, Memory, Network, Processes, Scheduler, SCSI,
                Dom_Info_Brief, Bridge_Config

    @return    "success:" followed by the status data in XML, or
               "failed:" followed by an error message
    """
    (sts, response, logmsg) = OVSDiscoverExtension.status(args)
    return format_extn_response(sts, response, logmsg)

# Debuging wrapper to send a traceback in the XMLRPC reply
# def discover(args):
#     try:
#         return real_discover(args)
#     except Exception, e:
#         import traceback
##        traceback.print_exc()  # Print it locally
#         result = "failed:" + traceback.format_exc()
#         return result
