# Copyright (C) 2006-2011 Oracle. All rights reserved.
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation, version 2.  This program is distributed in the hope that it will
# be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
# Public License for more details.  You should have received a copy of the GNU
# General Public License along with this program; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 021110-1307, USA.

import logging
import logging.handlers
from OVSConfig import get_config


def init_log():
    config = get_config()
    logger = logging.getLogger()
    logger.propagate = 0
    handler = logging.handlers.SocketHandler('127.0.0.1',
                  logging.handlers.DEFAULT_TCP_LOGGING_PORT)
    logger.addHandler(handler)
    loglevel = logging.getLevelName(config.get('logger', 'log-level'))
    logger.setLevel(loglevel)
