# Copyright (C) 2006-2011 Oracle. All rights reserved.
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation, version 2.  This program is distributed in the hope that it will
# be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
# Public License for more details.  You should have received a copy of the GNU
# General Public License along with this program; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 021110-1307, USA.

import logging
import cPickle
import socket
import struct
from OVSConstants import NOTIFICATION_SERVER_ADDRESS


def notify_manager(notification, data=None):
    from OVSServerPool import get_manager_core_api_url
    url = get_manager_core_api_url()
    if not url:
        raise Exception("Cannot get manager URL from agent db.")

    if data is None:
        data = {}

    try:
        soc = socket.socket(socket.AF_UNIX, socket.SOCK_STREAM)
    except Exception,e:
        logging.error("Unable to get notification socket: %s", e)
        raise e

    try:
        msg = cPickle.dumps((notification, data))
        msglen = struct.pack(">L", len(msg))
        try:
            soc.connect(NOTIFICATION_SERVER_ADDRESS)
            soc.sendall(msglen + msg)
        except Exception, e:
            logging.error("Unable to send notification: %s", e)
            raise e
        if not notification.startswith('{STATS}'):
            logging.debug('Notification sent: %s', notification)
    finally:
        soc.close()
